/***********************************************************************/
/*                                                                     */
/*  FILE        :vector_table.c                                        */
/*  DATE        :Mon, Jun 29, 2015                                     */
/*  DESCRIPTION :Vector Table                                          */
/*  CPU TYPE    :RX63N                                                 */
/*                                                                     */
/*  This file is generated by KPIT GNU Project Generator.              */
/*                                                                     */
/***********************************************************************/
                          

                 
                                                                          
#include "interrupt_handlers.h"

typedef void (*fp) (void);
extern void PowerON_Reset (void);
extern void stack (void);

#define FVECT_SECT          __attribute__ ((section (".fvectors")))

const void *HardwareVectors[] FVECT_SECT  = {
//;0xffffff80  MDES - Endian Select Register
#ifdef __RX_LITTLE_ENDIAN__     
    (fp)0xffffffff,
#endif
#ifdef __RX_BIG_ENDIAN__       
    (fp)0xfffffff8,
#endif
//;0xffffff84  Reserved
    (fp)0xffffffff,
//;0xffffff88  Reserved
    (fp)0xffffffff,
//;0xffffff8C  Reserved
    (fp)0xffffffff,
//;0xffffff90  Reserved
    (fp)0xffffffff,
//;0xffffff94  Reserved
    (fp)0xffffffff,
//;0xffffff98  Reserved
    (fp)0xffffffff,
//;0xffffff9C  Reserved
    (fp)0xffffffff,
//;0xffffffA0  Reserved
    (fp)0xffffffff,
//;0xffffffA4  Reserved
    (fp)0xffffffff,
//;0xffffffA8  Reserved
    (fp)0xffffffff,
//;0xffffffAC  Reserved
    (fp)0xffffffff,
//;0xffffffB0  Reserved
    (fp)0xffffffff,
//;0xffffffB4  Reserved
    (fp)0xffffffff,
//;0xffffffB8  Reserved
    (fp)0xffffffff,
//;0xffffffBC  Reserved
    (fp)0xffffffff,
//;0xffffffC0  Reserved
    (fp)0xffffffff,
//;0xffffffC4  Reserved
    (fp)0xffffffff,
//;0xffffffC8  Reserved
    (fp)0xffffffff,
//;0xffffffCC  Reserved
    (fp)0xffffffff,
//;0xffffffd0  Exception(Supervisor Instruction)
    Excep_SuperVisorInst,
//;0xffffffd4  Reserved
    (fp)0,
//;0xffffffd8  Reserved
    (fp)0,
//;0xffffffdc  Exception(Undefined Instruction)
    Excep_UndefinedInst,
//;0xffffffe0  Reserved
    (fp)0,
//;0xffffffe4  Exception(Floating Point)
    Excep_FloatingPoint,
//;0xffffffe8  Reserved
    (fp)0,
//;0xffffffec  Reserved
    (fp)0,
//;0xfffffff0  Reserved
    (fp)0,
//;0xfffffff4  Reserved
    (fp)0,
//;0xfffffff8  NMI
    NonMaskableInterrupt,
//;0xfffffffc  RESET
//;<<VECTOR DATA START (POWER ON RESET)>>
//;Power On Reset PC
    PowerON_Reset                                                                                                                  
//;<<VECTOR DATA END (POWER ON RESET)>>
};


#define RVECT_SECT          __attribute__ ((section (".rvectors")))

const fp RelocatableVectors[] RVECT_SECT  = {
//;0x0000  Reserved
    (fp)Excep_BRK,
//;0x0004  Reserved
    (fp)0,
//;0x0008  Reserved
    (fp)0,
//;0x000C  Reserved
    (fp)0,
//;0x0010  Reserved
    (fp)0,
//;0x0014  Reserved
    (fp)0,
//;0x0018  Reserved
    (fp)0,
//;0x001C  Reserved
    (fp)0,
//;0x0020  Reserved
    (fp)0,
//;0x0024  Reserved
    (fp)0,
//;0x0028  Reserved
    (fp)0,
//;0x002C  Reserved
    (fp)0,
//;0x0030  Reserved
    (fp)0,
//;0x0034  Reserved
    (fp)0,
//;0x0038  Reserved
    (fp)0,
//;0x003C  Reserved
    (fp)0,
//;0x0040  BUSERR
	(fp)Excep_BUSERR,
//;0x0044  Reserved
    (fp)0,
//;0x0048  Reserved
    (fp)0,
//;0x004C  Reserved
    (fp)0,
//;0x0050  Reserved
    (fp)0,
//;0x0054 FCU_FCUERR
	(fp)Excep_FCUIF_FIFEERR,
//;0x0058  Reserved
    (fp)0,
//;0x005C  FCU_FRDYI
	(fp)Excep_FCUIF_FRDYI,  
//;0x0060  Reserved
    (fp)0,
//;0x0064  Reserved
    (fp)0,
//;0x0068  Reserved
    (fp)0,
//;0x006C  ICU_SWINT													
    (fp)Excep_ICU_SWINT,				
//;0x0070  CMTU0_CMT0									
	(fp)Excep_CMT0_CMI0,
//;0x0074  CMTU1_CMT1
	(fp)Excep_CMT1_CMI1,
//;0x0078  CMTU2_CMT2
	(fp)Excep_CMT2_CMI2,
//;0x007C  CMTU3_CMT3
	(fp)Excep_CMT3_CMI3,
//;0x0080  ETHER_EINT				
	(fp)Excep_ETHER_EINT,	
//;0x0084  USB0_D0FIFO0				
	(fp)Excep_USB0_D0FIFO0,	
//;0x0088  USB0_D1FIFO0
	(fp)Excep_USB0_D1FIFO0,
//;0x008C  USB0_USBI0
	(fp)Excep_USB0_USBI0,
//;0x0090 USB1_D0FIFO1
	(fp)Excep_USB1_D0FIFO1,	
//;0x0094  USB1_D1FIFO1
	(fp)Excep_USB1_D1FIFO1,
//;0x0098  USB1_USBI1
	(fp)Excep_USB1_USBI1,	
//;0x009C  RSPI0 SPRI0
	(fp)Excep_RSPI0_SPRI0,
//;0x00A0  RSPI0_SPRI0
	(fp)Excep_RSPI0_SPTI0,
//;0x00A4  RSPI0_SPTI0
    (fp)Excep_RSPI0_SPII0,
//;0x00A8  RSPI1_SPII1
    (fp)Excep_RSPI1_SPRI1,
//;0x00AC  RSPI1_SPTI1
	(fp)Excep_RSPI1_SPTI1,	
//;0x00B0  RSPI1_SPII1
	(fp)Excep_RSPI1_SPII1,
//;0x00B4  RSPI2_SPRI2
    (fp)Excep_RSPI2_SPRI2, 
//;0x00B8  RSPI2_SPTI2
    (fp)Excep_RSPI2_SPTI2,	
//;0x00BC  RSPI2_SPII2
    (fp)Excep_RSPI2_SPII2,
//;0x00C0  CAN0_RXF0
    (fp)Excep_CAN0_RXF0,
//;0x00C4  CAN0_TXF0
    (fp)Excep_CAN0_TXF0,	
//;0x00C8  CAN0_RXM0
    (fp)Excep_CAN0_RXM0,
//;0x00CC  CAN0_TXM0
    (fp)Excep_CAN0_TXM0,
//;0x00D0  CAN1_RXF1
    (fp)Excep_CAN1_RXF1,
//;0x00D4  CAN1_TXF1
    (fp)Excep_CAN1_TXF1,	
//;0x00D8  CAN1_RXM1
    (fp)Excep_CAN1_RXM1,
//;0x00DC  CAN1_TXM1
    (fp)Excep_CAN2_TXM2,
//;0x00E0  CAN2_RXF2
    (fp)Excep_CAN2_RXF2,
//;0x00E4  CAN2_TXF2
    (fp)Excep_CAN2_TXF2,	
//;0x00E8  CAN2_RXM2
    (fp)Excep_CAN2_RXM2,
//;0x00EC  CAN2_TXM2
    (fp)Excep_CAN2_TXM2,
//;0x0F0  Reserved
    (fp)0,	
//;0x0F4  Reserved
    (fp)0,
//;0x0F8   RTC_CUP	
	(fp)Excep_RTC_CUP,
//;0x00FC  Reserved
    (fp)0,
//;0x0100  IRQ0
    (fp)Excep_IRQ0,
//;0x0104 IRQ1
    (fp)Excep_IRQ1,
//;0x0108 IRQ2
    (fp)Excep_IRQ2,
//;0x010C IRQ3
    (fp)Excep_IRQ3,
//;0x0110 IRQ4
    (fp)Excep_IRQ4,
//;0x0114 IRQ5
    (fp)Excep_IRQ5,
//;0x0118 IRQ6
    (fp)Excep_IRQ6,
//;0x011C IRQ7
    (fp)Excep_IRQ7,
//;0x0120 IRQ8
    (fp)Excep_IRQ8,
//;0x0124 IRQ9
    (fp)Excep_IRQ9,
//;0x0128 IRQ10
    (fp)Excep_IRQ10,
//;0x012C IRQ11
    (fp)Excep_IRQ11,
//;0x0130 IRQ12
    (fp)Excep_IRQ12,
//;0x0134 IRQ13
    (fp)Excep_IRQ13,
//;0x0138 IRQ14
    (fp)Excep_IRQ14,
//;0x013C IRQ15
    (fp)Excep_IRQ15,
//;0x0140  Reserved
    (fp)0,
//;0x0144  Reserved
    (fp)0,
//;0x0148  Reserved
    (fp)0,
//;0x014C  Reserved
    (fp)0,
//;0x0150  Reserved
    (fp)0,
//;0x0154  Reserved
    (fp)0,
//;0x0158  Reserved
    (fp)0,
//;0x015C  Reserved
    (fp)0,
//;0x0160  Reserved
    (fp)0,
//;0x0164  Reserved
    (fp)0,
//;0x0168  USB RESUME USBR0
    (fp)Excep_USB_USBR0,
//;0x016C  USB RESUME USBR1
    (fp)Excep_USB_USBR1,
//;0x0170  RTC_ALM
    (fp)Excep_RTC_ALM,		
//;0x0174  RTC_PRD
    (fp)Excep_RTC_SLEEP,
//;0x0178  Reserved
    (fp)0,
//;0x017C  Reserved
    (fp)0,
//;0x0180  Reserved
    (fp)0,
//;0x0184  Reserved
    (fp)0,
//;0x0188  AD0_ADI0
    (fp)Excep_ADA0_ADI0,
//;0x018C  Reserved
    (fp)0,
//;0x0190  Reserved
    (fp)0,
//;0x0194  Reserved
    (fp)0,
//;0x0198  S12AD_ADI12_0
	(fp)Excep_S12AD0_S12ADI0,
//;0x019C  Reserved
    (fp)0,										
//;0x01A0  Reserved
	(fp)0,
//;0x01A4  Reserved
    (fp)0,	
//;0x01A8  GROUP_E0
    (fp)Excep_GROUP_E0,
//;0x01AC  GROUP_E1
    (fp)Excep_GROUP_E1,
//;0x01B0  GROUP_E2
    (fp)Excep_GROUP_E2,	
//;0x01B4  GROUP_E3
    (fp)Excep_GROUP_E3,						
//;0x01B8  GROUP_E4
    (fp)Excep_GROUP_E4,
//;0x01BC  GROUP_E5
	(fp)Excep_GROUP_E5,
//;0x01C0  GROUP_E6
	(fp)Excep_GROUP_E6,
//;0x01C4  Reserved
    (fp)0,
//;0x1C8	GROUP_L0
    (fp)Excep_GROUP_L0,
//;0x01CC  Reserved
    (fp)0,
//;0x01D0  Reserved
    (fp)0,
//;0x01D4  Reserved
    (fp)0,
//;0x01D8  Reserved
    (fp)0,
//;0x01DC  Reserved
    (fp)0,	
//;0x01E0  Reserved
    (fp)0,
//;0x01E4  Reserved
    (fp)0,
//;0x01E8 SCIX_SCIX0
 	(fp)Excep_SCIX_SCIX0,
//;0x01EC SCIX_SCIX1
 	(fp)Excep_SCIX_SCIX1,
//;0x01F0 SCIX_SCIX2
 	(fp)Excep_SCIX_SCIX2,  
//;0x01F4 SCIX_SCIX3
 	(fp)Excep_SCIX_SCIX3,
//;0x01F8  TPU0 TGIA0
    (fp)Excep_TPU0_TGIA0,
//;0x01FC  TPU0 TGIB0
    (fp)Excep_TPU0_TGIB0,
//;0x0200 TPU0 TGIC0
    (fp)Excep_TPU0_TGIC0,
//;0x0204 TPU0 TGID0
    (fp)Excep_TPU0_TGID0,
//;0x0208 TPU1 TGIA1
    (fp)Excep_TPU1_TGIA1,
//;0x020C TPU1 TGIB1
    (fp)Excep_TPU1_TGIB1,
//;0x0210 TPU2 TGIA2
    (fp)Excep_TPU2_TGIA2,
//;0x0214 TPU2 TGIB2
    (fp)Excep_TPU2_TGIB2,
//;0x0218 TPU3 TGIA3
    (fp)Excep_TPU3_TGIA3,
//;0x021C TPU3 TGIB3
    (fp)Excep_TPU3_TGIB3,
//;0x0220 TPU3 TGIC3
    (fp)Excep_TPU3_TGIC3,
//;0x0224 TPU3 TGID3
    (fp)Excep_TPU3_TGID3,
//;0x0228 TPU4 TGIA4
    (fp)Excep_TPU4_TGIA4,
//;0x022C TPU4 TGIB4
    (fp)Excep_TPU4_TGIB4,
//;0x0230 TPU5 TGIA15
    (fp)Excep_TPU5_TGIA5,
//;0x0234 TPU5 TGIB5
    (fp)Excep_TPU5_TGIB5,
//;0x0238 TPU6/MTU0 TGIA6/TGIA0
    (fp)Excep_TPU6_TGIA6,
//;0x023C TPU6/MTU0 TGIB6/TGIB0
    (fp)Excep_TPU6_TGIB6,
//;0x0240 TPU6/MTU0 TGIC6/TGIC0
    (fp)Excep_TPU6_TGIC6,
//;0x0244 TPU6/MTU0 TGID6/TGID0
    (fp)Excep_TPU6_TGID6,
//;0x0248 TPU6/MTU0 TGIE6/TGIE0
    (fp)Excep_TPU6_TGIE6,
//;0x024C TPU6/MTU0 TGIF6/TGIF0
    (fp)Excep_TPU6_TGIF6,
//;0x0250 TPU7/MTU1 TGIA7/TGIA1
    (fp)Excep_TPU7_TGIA7,
//;0x0254 TPU7/MTU1 TGIB7/TGIB1
    (fp)Excep_TPU7_TGIB7,
//;0x0258 TPU8/MTU2 TGIA8/TGIA2
    (fp)Excep_TPU8_TGIA8,
//;0x025C TPU8/MTU2 TGIB8/TGIB2
    (fp)Excep_TPU8_TGIB8,
//;0x0260 TPU9/MTU3 TGIA9/TGIA3
    (fp)Excep_TPU9_TGIA9,
//;0x0264 TPU9/MTU3 TGIB9/TGIB3
    (fp)Excep_TPU9_TGIB9,
//;0x0268 TPU9/MTU3 TGIC9/TGIC3
    (fp)Excep_TPU9_TGIC9,
//;0x026C TPU9/MTU3 TGID9/TGID3
    (fp)Excep_TPU9_TGID9,
//;0x0270 TPU10/MTU4 TGIA10/TGIA4
    (fp)Excep_TPU10_TGIA10,
//;0x0274 TPU10/MTU4 TGIB10/TGIB4
    (fp)Excep_TPU10_TGIB10,
//;0x0278 TPU10/MTU4 TGIC10/TGIC4
    (fp)Excep_TPU10_TGIC10,
//;0x027C TPU10/MTU4 TGID10/TGID4
    (fp)Excep_TPU10_TGID10,
//;0x0280 TPU10/MTU4 TGIV10/TGIV4
    (fp)Excep_TPU10_TGIV10,
//;0x0284 MTU5 TGIU5
    (fp)Excep_MTU5_TGIU5,
//;0x0288 MTU5 TGIV5
    (fp)Excep_MTU5_TGIV5,
//;0x028C MTU5 TGIW5
    (fp)Excep_MTU5_TGIW5,
//;0x0290 TPU11 TGIA11
    (fp)Excep_TPU11_TGIA11,
//;0x0294 TPU11 TGIB11
    (fp)Excep_TPU11_TGIB11,
//;0x0298 POE2 OEI1
    (fp)Excep_POE2_OEI1,
//;0x029C POE2 OEI2
    (fp)Excep_POE2_OEI2,
//;0x02A0  Reserved
    (fp)0,
//;0x02A4  Reserved
    (fp)0,	
//;0x02A8 TMR0_CMIA0
    (fp)Excep_TMR0_CMIA0,
//;0x02AC TMR0_CMIB0
    (fp)Excep_TMR0_CMIB0,
//;0x02B0 TMR0_OVI0
    (fp)Excep_TMR0_OVI0,
//;0x02B4 TMR1_CMIA1
    (fp)Excep_TMR1_CMIA1,
//;0x02B8 TMR1_CMIB1
    (fp)Excep_TMR1_CMIB1,
//;0x02BC TMR1_OVI1
    (fp)Excep_TMR1_OVI1,
//;0x02C0 TMR2_CMIA2
    (fp)Excep_TMR2_CMIA2,
//;0x02C4 TMR2_CMIB2
    (fp)Excep_TMR2_CMIB2,
//;0x02C8 TMR2_OVI2
    (fp)Excep_TMR2_OVI2,
//;0x02CC TMR3_CMIA3
    (fp)Excep_TMR3_CMIA3,
//;0x02D0 TMR3_CMIB3
    (fp)Excep_TMR3_CMIB3,
//;0x02D4 TMR3_OVI3
    (fp)Excep_TMR3_OVI3,
//;0x02D8 RIIC0 EEI0
    (fp)Excep_RIIC0_EEI0,
//;0x02DC RIIC0 RXI0
    (fp)Excep_RIIC0_RXI0,
//;0x02E0 RIIC0 TXI0
    (fp)Excep_RIIC0_TXI0,
//;0x02E4 RIIC0 TEI0
    (fp)Excep_RIIC0_TEI0,
//;0x02E8 RIIC1 EEI0
    (fp)Excep_RIIC1_EEI0,
//;0x02EC RIIC1 RXI0
    (fp)Excep_RIIC1_RXI0,
//;0x02F0 RIIC1 TXI0
    (fp)Excep_RIIC1_TXI0,
//;0x02F4 RIIC1 TEI0
    (fp)Excep_RIIC1_TEI0,
//;0x02F8 RIIC2 EEI0
    (fp)Excep_RIIC2_EEI0,
//;0x02FC RIIC2 RXI0
    (fp)Excep_RIIC2_RXI0,
//;0x0300 RIIC2 TXI0
    (fp)Excep_RIIC2_TXI0,
//;0x0304 RIIC2 TEI0
    (fp)Excep_RIIC2_TEI0,
//;0x0308 RIIC3 EEI0
    (fp)Excep_RIIC3_EEI0,
//;0x030C RIIC3 RXI0
    (fp)Excep_RIIC3_RXI0,
//;0x0310 RIIC3 TXI0
    (fp)Excep_RIIC3_TXI0,
//;0x0314 RIIC3 TEI0
    (fp)Excep_RIIC3_TEI0,
//;0x0318 DMACA DMAC0
    (fp)Excep_DMACA_DMAC0,
//;0x031C DMAC DMAC1
    (fp)Excep_DMACA_DMAC1,
//;0x0320 DMAC DMAC2
    (fp)Excep_DMACA_DMAC2,
//;0x0324 DMAC DMAC3
    (fp)Excep_DMACA_DMAC3,
//;0x0328 EXDMAC DMAC0
    (fp)Excep_EXDMAC_DMAC0,
//;0x032C EXDMAC DMAC1
    (fp)Excep_EXDMAC_DMAC1,
//;0x0330  Reserved
    (fp)0,
//;0x0334  Reserved
    (fp)0,
//;0x0338  Reserved
    (fp)0,
//;0x033C  Reserved
    (fp)0,
//;0x0340  Reserved
    (fp)0,
//;0x0344  Reserved
    (fp)0,
//;0x0348  Reserved
    (fp)0,
//;0x034C  Reserved
    (fp)0,
//;0x0350  Reserved
    (fp)0,
//;0x0354  Reserved
    (fp)0,
//;0x0358 SCI0_RXI0
    (fp)Excep_SCI0_RXI0,
//;0x035C SCI0_TXI0
    (fp)Excep_SCI0_TXI0,
//;0x0360 SCI0_TEI0
    (fp)Excep_SCI0_TEI0,
//;0x0364 SCI1_RXI1
    (fp)Excep_SCI1_RXI1,
//;0x0368 SCI1_TXI1
    (fp)Excep_SCI1_TXI1,
//;0x036C SCI1_TEI1
    (fp)Excep_SCI1_TEI1,
//;0x0370 SCI2_RXI2
    (fp)Excep_SCI2_RXI2,
//;0x0374 SCI2_TXI2
    (fp)Excep_SCI2_TXI2,
//;0x0378 SCI2_TEI2
    (fp)Excep_SCI2_TEI2,
//;0x037C SCI3_RXI3
    (fp)Excep_SCI3_RXI3,
//;0x0380 SCI3_TXI3
    (fp)Excep_SCI3_TXI3,
//;0x0384 SCI3_TEI3
    (fp)Excep_SCI3_TEI3,
//;0x0388 SCI4_RXI4
    (fp)Excep_SCI4_RXI4,
//;0x038C SCI4_TXI4
    (fp)Excep_SCI4_TXI4,
//;0x0390 SCI4_TEI4
    (fp)Excep_SCI4_TEI4,
//;0x0394 SCI5_RXI5
    (fp)Excep_SCI5_RXI5,
//;0x0398 SCI5_TXI5
    (fp)Excep_SCI5_TXI5,
//;0x039C SCI5_TEI5
    (fp)Excep_SCI5_TEI5,
//;0x03A0 SCI6_RXI6
    (fp)Excep_SCI6_RXI6,
//;0x03A4 SCI6_TXI6
    (fp)Excep_SCI6_TXI6,
//;0x03A8 SCI6_TEI6
    (fp)Excep_SCI6_TEI6,
//;0x03AC SCI7_RXI7
    (fp)Excep_SCI7_RXI7,
//;0x03B0 SCI7_TXI7
    (fp)Excep_SCI7_TXI7,
//;0x03B4 SCI7_TEI7
    (fp)Excep_SCI7_TEI7,
//;0x03B8 SCI8_RXI8
    (fp)Excep_SCI8_RXI8,
//;0x03BC SCI8_TXI8
    (fp)Excep_SCI8_TXI8,
//;0x03C0 SCI8_TEI8
    (fp)Excep_SCI8_TEI8,
//;0x03C4 SCI9_RXI9
    (fp)Excep_SCI9_RXI9,
//;0x03C8 SCI9_TXI9
    (fp)Excep_SCI9_TXI9,
//;0x03CC SCI9_TEI9
    (fp)Excep_SCI9_TEI9,
//;0x03D0 SCI10_RXI10
    (fp)Excep_SCI10_RXI10,
//;0x03D4 SCI10_TXI10
    (fp)Excep_SCI10_TXI10,
//;0x03D8 SCI10_TEI10
    (fp)Excep_SCI10_TEI10,
//;0x03DC SCI11_RXI11
    (fp)Excep_SCI11_RXI11,
//;0x03E0 SCI11_TXI11
    (fp)Excep_SCI11_TXI11,
//;0x03E4 SCI11_TEI11
    (fp)Excep_SCI11_TEI11,
//;0x03E8 SCI12_RXI12
    (fp)Excep_SCI12_RXI12,
//;0x03EC SCI12_TXI12
    (fp)Excep_SCI12_TXI12,
//;0x03F0 SCI12_TEI12
    (fp)Excep_SCI12_TEI12,
//;0x03F4 IEBUS IEBINT
    (fp)Excep_IEBUS_IEBINT,
//;0x03F8  Reserved
    (fp)0,
//;0x03FC  Reserved
    (fp)0,
};
